//All the main code goes here

RequireSystemScript("time.js");

var font = LoadFont("txt.rfn");
var hudfont = LoadFont("hud.rfn");
var healthbar = LoadWindowStyle("healthbar.rws");
var red = CreateColor(255, 0, 0);
var enemies = 0;
var gotkey = false;
var condition = undefined;
var shield = LoadImage("shield.png");

function game(){
	//Intro();
	TitleScreen();
	Begin();
}

function Intro(){

}

function TitleScreen(){
	var music = LoadSound("CLASS01.MOD");
	var bg = LoadImage("title.png");
	var windowstyle = LoadWindowStyle("txt.rws");
	var font = LoadFont("txt.rfn");
	var fontbg = LoadFont("txtbg.rfn");
	//music.play(true);
	bg.blit(0, 0);
	FlipScreen();
	GetKey();
	music.stop();
}

function Txt(txt){
	var windowstyle = LoadWindowStyle("txt.rws");
	var font = LoadFont("txt.rfn");
	var fontbg = LoadFont("txtbg.rfn");

	RenderMap();
	windowstyle.drawWindow(16, 16, 288, 50);
	fontbg.drawTextBox(17, 17, 288, 50, 0, txt);
	font.drawTextBox(16, 16, 288, 50, 0, txt);

	FlipScreen();
	GetKey(KEY_SPACE);
}

function Begin(){
	MapEngine("1.rmp", 60);
}

function Enemy(life, type, script){
	enemies = enemies + 1;
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_CREATE, "SetPersonSpeed(GetCurrentPerson(), 3);");
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_DESTROY, "kills = kills+1; enemies = enemies - 1; HitText();");
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_ACTIVATE_TOUCH, "health = health-1");
	SetPersonScript(GetCurrentPerson(), SCRIPT_COMMAND_GENERATOR, "GenerateRandomMovement();");
}

function Shoot(){
	//if(!shooting){
			//shooting = true;
			CreatePerson("arrow", "lazer.rss", true);
			//SetPersonSpeed("arrow", 1);
			SetPersonIgnoreList("rin", ["arrow"]);
			SetPersonIgnoreList("arrow", ["rin", "door_to_next_level", "door_to_key", "key", "slime_1", "slime_2", "slime_3", "slime_4"]);

		switch(GetPersonDirection("rin")){
			case "north":
				SetPersonDirection("arrow", "north");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "east":
				SetPersonDirection("arrow", "east");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "south":
				SetPersonDirection("arrow", "south");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "west":
				SetPersonDirection("arrow", "west");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "northeast":
				SetPersonDirection("arrow", "northeast");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "southeast":
				SetPersonDirection("arrow", "southeast");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "southwest":
				SetPersonDirection("arrow", "southwest");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "northwest":
				SetPersonDirection("arrow", "northwest");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
		}
	//}
}

/*function Shoot(weapon, sprite, speed, ignore, damage){
	//if(!shooting){
			//shooting = true;
			CreatePerson(weapon, sprite, true);
			SetPersonSpeed(weapon, speed);
			SetPersonIgnoreList(ignore, [weapon]);
			SetPersonIgnoreList(weapon, [ignore]);

		switch(GetPersonDirection(GetCurrentPerson())){
			case "north":
				SetPersonDirection(weapon, "north");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
			case "east":
				SetPersonDirection(weapon, "east");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
			case "south":
				SetPersonDirection(weapon, "south");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
			case "west":
				SetPersonDirection(weapon, "west");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
			case "northeast":
				SetPersonDirection(weapon, "northeast");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
			case "southeast":
				SetPersonDirection(weapon, "southeast");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
			case "southwest":
				SetPersonDirection(weapon, "southwest");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
			case "northwest":
				SetPersonDirection(weapon, "northwest");
				SetPersonX(weapon, GetPersonX(GetCurrentPerson()));
				SetPersonY(weapon, GetPersonY(GetCurrentPerson()));
				break;
		}
	//}
}*/

//bestaat de pijl?
//var shooting = false;
//var arrowexists = false;

//Updatescript controleert of arrow bestaat
function UpdateScript(){
	var persons = GetPersonList();
	if(health == 0){
		Txt("YOU LOSE!!!");
		Exit();
	}
	if(!enemies){
		//DestroyPerson("door_to_key");
	}
	for (var i = persons.length; i > 0; i--){
		if(persons[i] == "arrow"){
			arrowexists = true;
			shooting = true;
			//QueuePersonCommand("arrow", COMMAND_MOVE_EAST, 1);
			switch(GetPersonDirection("arrow")){
				case "north":
					SetPersonY("arrow", GetPersonY("arrow")-10);
					break;
				case "east":
					SetPersonX("arrow", GetPersonX("arrow")+10);
					break;
				case "south":
					SetPersonY("arrow", GetPersonY("arrow")+10);
					break;
				case "west":
					SetPersonX("arrow", GetPersonX("arrow")-10);
					break;
				case "northeast":
					SetPersonX("arrow", GetPersonX("arrow")+10);
					SetPersonY("arrow", GetPersonY("arrow")-10);
					break;
				case "southeast":
					SetPersonX("arrow", GetPersonX("arrow")+10);
					SetPersonY("arrow", GetPersonY("arrow")+10);
					break;
				case "southwest":
					SetPersonX("arrow", GetPersonX("arrow")-10);
					SetPersonY("arrow", GetPersonY("arrow")+10);
					break;
				case "northwest":
					SetPersonX("arrow", GetPersonX("arrow")-10);
					SetPersonY("arrow", GetPersonY("arrow")-10);
					break;
		}
		if(persons[i] != "arrow"){
			//arrowexists = false;
			//shooting = false;
		}
			if(IsPersonObstructed("arrow", GetPersonX("arrow"), GetPersonY("arrow"))){
				var obstructingperson = GetObstructingPerson("arrow", GetPersonX("arrow"), GetPersonY("arrow"));
				var obstructingtile = GetObstructingTile("arrow", GetPersonX("arrow"), GetPersonY("arrow"));
				if(obstructingperson != ""){
					//GetClife = life - 1;
					DestroyPerson(GetObstructingPerson("arrow", GetPersonX("arrow"), GetPersonY("arrow")));
				}
				if(obstructingtile == -1){
					
				}
				DestroyPerson("arrow");
			}
			break;
		}
	}
}

//renderscript laat mij de nodige informatie zien in het spel
function RenderScript(){
	healthbar.drawWindow(16, 219, 100, 5);
	Rectangle(16, 219, health*10, 5, red);
	hudfont.drawText(16, 16, "Enemies destroyed: " + kills);
	hudfont.drawText(16, 32, "Enemies left: " + enemies);
	hudfont.drawText(16, 48, "Got key: " + gotkey);
}

//Programmeer hier random movement!!!
function FindMove(){

	var rinx = GetPersonX("rin");
	var riny = GetPersonY("rin");

	switch(rinx){
		case rinx < GetPersonX(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_WEST, 1);
			break;
		case rinx > GetPersonX(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_EAST, 1);
			break;
	}
	switch(riny){
		case riny < GetPersonY(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_SOUTH, 1);
			break;
		case riny > GetPersonY(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_NORTH, 1);
			break;
			}
}

function Move(name, command, tiles, immediate)
{
  switch (command)
  {
    case COMMAND_MOVE_NORTH:
      QueuePersonCommand(name, COMMAND_FACE_NORTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_SOUTH:
      QueuePersonCommand(name, COMMAND_FACE_SOUTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_EAST:
      QueuePersonCommand(name, COMMAND_FACE_EAST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_WEST:
      QueuePersonCommand(name, COMMAND_FACE_WEST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;
  }
}

function GenerateRandomMovement()
{
  var person = GetCurrentPerson();
  var commands = new Array(COMMAND_MOVE_NORTH, COMMAND_MOVE_EAST, COMMAND_MOVE_SOUTH, COMMAND_MOVE_WEST);
  var r1 = Math.floor(Math.random() * commands.length);
  var r2 = Math.floor(Math.random() * 3); // 3 being the number of tiles

  Move(person, commands[r1], r2, false);
}

function HealthBar(){
	healthbar.drawWindow(16, 208, health*10, 5);
	FlipScreen();
}

function HitText(){
	//RenderMap();
	//font.drawText(GetPersonX(GetCurrentPerson()), GetPersonY(GetCurrentPerson()), "Hit!")
	//FlipScreen();
}

function Key(){
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_ACTIVATE_TOUCH, "gotkey = true; DestroyPerson(GetCurrentPerson());");
}

function Door(condition, endlevel, nextlevel){
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_ACTIVATE_TOUCH, "if(condition){ DestroyPerson(GetCurrentPerson()); }")
}

function Slime(){
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_CREATE, "SetPersonSpeed(GetCurrentPerson(), 0.2);");
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_ACTIVATE_TOUCH, "health = health-1");
	SetPersonScript(GetCurrentPerson(), SCRIPT_COMMAND_GENERATOR, "GenerateRandomMovement();");
}

function WinLevel(map){
	shield.blit(0, 0);
	FlipScreen();
	GetKey();
	ChangeMap(map);
}