RequireSystemScript("time.js");

var font = LoadFont("txt.rfn");
var healthbar = LoadWindowStyle("healthbar.rws");
var red = CreateColor(255, 0, 0);
var enemies = 0;

function game(){
	//Intro();
	TitleScreen();
	Begin();
}

function Intro(){

}

function TitleScreen(){
	var music = LoadSound("CLASS01.MOD");
	var bg = LoadImage("title.png");
	var windowstyle = LoadWindowStyle("txt.rws");
	var font = LoadFont("txt.rfn");
	var fontbg = LoadFont("txtbg.rfn");
	music.play(true);
	bg.blit(0, 0);
	FlipScreen();
	GetKey();
	music.stop();
}

function Txt(txt){
	var windowstyle = LoadWindowStyle("txt.rws");
	var font = LoadFont("txt.rfn");
	var fontbg = LoadFont("txtbg.rfn");

	RenderMap();
	windowstyle.drawWindow(16, 16, 288, 52);
	fontbg.drawTextBox(17, 17, 288, 20, 0, txt);
	font.drawTextBox(16, 16, 288, 20, 0, txt);

	FlipScreen();
	GetKey(KEY_SPACE);
}

function Begin(){
	MapEngine("arena2.rmp", 60);
}

function MakeEnemy(){
	enemies = enemies + 1;
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_CREATE, "SetPersonSpeed(GetCurrentPerson(), 3);");
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_DESTROY, "kills = kills+1; enemies = enemies - 1; HitText();");
	SetPersonScript(GetCurrentPerson(), SCRIPT_ON_ACTIVATE_TOUCH, "health = health-1");
	SetPersonScript(GetCurrentPerson(), SCRIPT_COMMAND_GENERATOR, "GenerateRandomMovement();");
}

function ShootRin(){
	//if(!shooting){
			//shooting = true;
			CreatePerson("arrow", "arrow.rss", true);
			SetPersonSpeed("arrow", 10);
			SetPersonIgnoreList("rin", ["arrow"]);
			SetPersonIgnoreList("arrow", ["rin"]);

		switch(GetPersonDirection("rin")){
			case "north":
				SetPersonDirection("arrow", "north");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "east":
				SetPersonDirection("arrow", "east");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "south":
				SetPersonDirection("arrow", "south");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "west":
				SetPersonDirection("arrow", "west");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "northeast":
				SetPersonDirection("arrow", "northeast");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "southeast":
				SetPersonDirection("arrow", "southeast");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "southwest":
				SetPersonDirection("arrow", "southwest");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
			case "northwest":
				SetPersonDirection("arrow", "northwest");
				SetPersonX("arrow", GetPersonX("rin"));
				SetPersonY("arrow", GetPersonY("rin"));
				break;
		}
	//}
}

function ShootRintu(){
	//if(!shooting){
			//shooting = true;
			CreatePerson("arrow", "arrow.rss", true);
			SetPersonSpeed("arrow", 10);
			SetPersonIgnoreList("rintu", ["arrow"]);
			SetPersonIgnoreList("arrow", ["rintu"]);

		switch(GetPersonDirection("rintu")){
			case "north":
				SetPersonDirection("arrow", "north");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
			case "east":
				SetPersonDirection("arrow", "east");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
			case "south":
				SetPersonDirection("arrow", "south");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
			case "west":
				SetPersonDirection("arrow", "west");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
			case "northeast":
				SetPersonDirection("arrow", "northeast");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
			case "southeast":
				SetPersonDirection("arrow", "southeast");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
			case "southwest":
				SetPersonDirection("arrow", "southwest");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
			case "northwest":
				SetPersonDirection("arrow", "northwest");
				SetPersonX("arrow", GetPersonX("rintu"));
				SetPersonY("arrow", GetPersonY("rintu"));
				break;
		}
	//}
}

//bestaat de pijl?
//var shooting = false;
//var arrowexists = false;

//Updatescript controleert of arrow bestaat
function UpdateScript(){
	//var dir = GetPersonDirection("rin");
	var persons = GetPersonList();
	if(health == 0){
		Txt("YOU LOSE!!!");
		Exit();
	}
	if(!enemies){
		Txt("You win!");
		Exit();
	}
	for (var i = persons.length; i > 0; i--){
		if(persons[i] == "arrow"){
			//arrowexists = true;
			//shooting = true;
			//QueuePersonCommand("arrow", COMMAND_MOVE_EAST, 1);
			switch(GetPersonDirection("arrow")){
				case "north":
					SetPersonY("arrow", GetPersonY("arrow")-10);
					break;
				case "east":
					SetPersonX("arrow", GetPersonX("arrow")+10);
					break;
				case "south":
					SetPersonY("arrow", GetPersonY("arrow")+10);
					break;
				case "west":
					SetPersonX("arrow", GetPersonX("arrow")-10);
					break;
				case "northeast":
					SetPersonX("arrow", GetPersonX("arrow")+10);
					SetPersonY("arrow", GetPersonY("arrow")-10);
					break;
				case "southeast":
					SetPersonX("arrow", GetPersonX("arrow")+10);
					SetPersonY("arrow", GetPersonY("arrow")+10);
					break;
				case "southwest":
					SetPersonX("arrow", GetPersonX("arrow")-10);
					SetPersonY("arrow", GetPersonY("arrow")+10);
					break;
				case "northwest":
					SetPersonX("arrow", GetPersonX("arrow")-10);
					SetPersonY("arrow", GetPersonY("arrow")-10);
					break;
		}
		if(persons[i] != "arrow"){
			//arrowexists = false;
			//shooting = false;
		}
			if(IsPersonObstructed("arrow", GetPersonX("arrow"), GetPersonY("arrow"))){
				var obstructingperson = GetObstructingPerson("arrow", GetPersonX("arrow"), GetPersonY("arrow"));
				var obstructingtile = GetObstructingTile("arrow", GetPersonX("arrow"), GetPersonY("arrow"));
				if(obstructingperson != ""){
					DestroyPerson(GetObstructingPerson("arrow", GetPersonX("arrow"), GetPersonY("arrow")));
				}
				if(obstructingtile == -1){
					
				}
				DestroyPerson("arrow");
			}
			break;
		}
	}
}

//renderscript laat mij de nodige informatie zien in het spel
function RenderScript(){
	healthbar.drawWindow(16, 208, 100, 16);
	Rectangle(16, 208, health*10, 16, red);
	font.drawText(16, 32, "Enemies destroyed: " + kills);
	font.drawText(16, 48, "Enemies left: " + enemies);
}

//Programmeer hier random movement!!!
function FindMove(){

	var rinx = GetPersonX("rin");
	var riny = GetPersonY("rin");

	switch(rinx){
		case rinx < GetPersonX(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_WEST, 1);
			break;
		case rinx > GetPersonX(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_EAST, 1);
			break;
	}
	switch(riny){
		case riny < GetPersonY(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_SOUTH, 1);
			break;
		case riny > GetPersonY(GetCurrentPerson()):
			QueuePersonCommand(GetCurrentPerson(), COMMAND_MOVE_NORTH, 1);
			break;
			}
}

function Move(name, command, tiles, immediate)
{
  switch (command)
  {
    case COMMAND_MOVE_NORTH:
      QueuePersonCommand(name, COMMAND_FACE_NORTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_SOUTH:
      QueuePersonCommand(name, COMMAND_FACE_SOUTH, immediate);
      for (var i = 0; i < GetTileHeight() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_EAST:
      QueuePersonCommand(name, COMMAND_FACE_EAST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;

    case COMMAND_MOVE_WEST:
      QueuePersonCommand(name, COMMAND_FACE_WEST, immediate);
      for (var i = 0; i < GetTileWidth() * tiles; ++i)
        QueuePersonCommand(name, command, false);
    break;
  }
}

function GenerateRandomMovement()
{
  var person = GetCurrentPerson();
  var commands = new Array(COMMAND_MOVE_NORTH, COMMAND_MOVE_EAST, COMMAND_MOVE_SOUTH, COMMAND_MOVE_WEST);
  var r1 = Math.floor(Math.random() * commands.length);
  var r2 = Math.floor(Math.random() * 3); // 3 being the number of tiles

  Move(person, commands[r1], r2, false);
}

function HealthBar(){
	healthbar.drawWindow(16, 208, health*10, 16);
	FlipScreen();
}

function HitText(){
	RenderMap();
	font.drawText(GetPersonX(GetCurrentPerson()), GetPersonY(GetCurrentPerson()), "Hit!")
	FlipScreen();
}